#include <iostream>
#include <Windows.h>
#include "../static_dll/exports.h"

#ifdef _DEBUG
#pragma comment(lib, "../Debug/static_dll.lib")
#else
#pragma comment(lib, "../Release/static_dll.lib")
#endif

__declspec(thread) int a = 5;

int main()
{
	char buf[128];

	std::cout << "Loaded static DLL, testing..." << std::endl;
	std::cout << static_dll_func1() << std::endl;
	static_dll_func3("alala", 678, buf);
	std::cout << buf << std::endl;
	std::cout << "Finished... Loading dynamic library..." << std::endl;


	HMODULE dll = LoadLibraryW(L"dynamic_dll.dll");
	if(!dll)
	{
		std::cout << "Error!" << std::endl;
		return -1;
	}


	typedef const char* (__stdcall* dynamic_dll_func1) ();
	typedef unsigned long (__stdcall* dynamic_dll_func2) (unsigned long x);
	typedef void (__stdcall* dynamic_dll_func3) (const char* text, unsigned long y, char* buf);

	dynamic_dll_func1 func1 = reinterpret_cast<dynamic_dll_func1>(GetProcAddress(dll, "dynamic_dll_func1"));
	dynamic_dll_func2 func2 = reinterpret_cast<dynamic_dll_func2>(GetProcAddress(dll, "dynamic_dll_func2"));
	dynamic_dll_func3 func3 = reinterpret_cast<dynamic_dll_func3>(GetProcAddress(dll, "dynamic_dll_func3"));
	
	if(!func1 || !func2 || !func3)
	{
		std::cout << "Error!" << std::endl;
		return -1;
	}

	
	std::cout << std::endl << "Loaded dynamic DLL, testing..." << std::endl;
	std::cout << func1() << std::endl;
	std::cout << dynamic_dll_func2(555) << std::endl;
	func3("alala", 678, buf);
	std::cout << buf << std::endl;
	std::cout << "Finished" << std::endl;

	std::cout << std::endl << "EXE TLS value: " << a << std::endl;
	std::cout << std::endl << "Static DLL TLS value: " << static_dll_func2() << std::endl;

	return 0;
}
